<?php
/**
 * @package    RSTickets! Pro
 *
 * @copyright  (c) 2010 - 2016 RSJoomla!
 * @link       https://www.rsjoomla.com
 * @license    GNU General Public License http://www.gnu.org/licenses/gpl-3.0.en.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');
	
abstract class JHtmlRSTicketsProIcon
{	
	// Deprecated
	public static function notify($is_staff, $ticket, $attribs = null) {
		if (!$is_staff || !RSTicketsProHelper::getConfig('autoclose_enabled') || $ticket->last_reply_customer || $ticket->autoclose_sent || $ticket->status_id == 2) {
			return;
		}
		
		$interval = RSTicketsProHelper::getConfig('autoclose_email_interval') * 86400;
		if ($interval < 86400) {
			$interval = 86400;
		}
		
		$date = JFactory::getDate();
		$date = $date->toUnix();
		$last_reply_interval = $ticket->last_reply + $interval;
		
		if ($last_reply_interval > $date)
		{
			return;
		}
		
		$overdue = floor(($date - $last_reply_interval) / 86400);
		
		$url = RSTicketsProHelper::route('index.php?option=com_rsticketspro&task=ticket.notify&cid='.$ticket->id);
		$img = JHtml::image('com_rsticketspro/notify.gif', JText::_('RST_TICKET_NOTIFY'),  'class="rst_notify_ticket"', true);
		
		$return = '<span class="'.RSTicketsProHelper::tooltipClass().'" title="'.RSTicketsProHelper::tooltipText(JText::sprintf('RST_TICKET_NOTIFY_DESC', $overdue)).'" '.$attribs.'><a href="'.$url.'">'.$img.'</a></span>';
		
		return $return;
	}
}

abstract class JHtmlRSTicketsProCalendar
{
    public static function calendar($value, $name, $id, $format = '%Y-%m-%d', $attribs = null, $show_time = false)
	{
		$params = array(
			'showTime' => $show_time ? 'true' : '0'
		);

        if ($attribs)
        {
            $params = array_merge($params, static::parseAttributes($attribs));
        }
		
		return JHtml::_('calendar', $value, $name, $id, $format, $params);
	}

    protected static function parseAttributes($string)
    {
        $parsed = array();

        // Let's grab all the key/value pairs using a regular expression
        if (preg_match_all('/([\w:-]+)[\s]?(=[\s]?"([^"]*)")?/i', $string, $attr))
        {
            $numPairs = count($attr[1]);
            for ($i = 0; $i < $numPairs; $i++)
            {
                $parsed[$attr[1][$i]] = $attr[3][$i];
            }
        }

        return $parsed;
    }
}